using UnityEngine;

namespace moyashi {
  public sealed class SharedUniforms {
    // need to temp store uniforms here in case they get set before the shader is loaded... kinda annoying
    // but avoids race condition between shader and stored json stuff loading

    // color correction
    public Vector3 ChannelMixR = new Vector3(1.0f, 0.0f, 0.0f);
    public Vector3 ChannelMixG = new Vector3(0.0f, 1.0f, 0.0f);
    public Vector3 ChannelMixB = new Vector3(0.0f, 0.0f, 1.0f);
    public float TonemappingScale = 1.0f;
    public float TonemappingExposure = 1.0f;
    public float ContrastScale = 0.0f;
    public float SaturationScale = 0.0f;
    public float SoftenScale = 1.0f;
    public float AtmosphereDensity = 0.0f;
    public float AtmosphereSeaLevel = 0.0f;
    public float AtmosphereSeaLevelDensity = 0.0f;
    public Color AtmosphereSkyColor = new Color(0.7f, 0.93f, 1.0f, 1.0f);
    public Color AtmosphereSunColor = new Color(1.0f, 0.99f, 0.83f, 1.0f);
    public float LUTScale = 1.0f;
    public Texture LUTTex;

    // fidelity fx CAS
    public float SharpeningScale = 0.3f;
    public Vector4 SharpeningConst0 = new Vector4(0.0f, 0.0f, 0.0f, 0.0f);
    public Vector4 SharpeningConst1 = new Vector4(0.0f, 0.0f, 0.0f, 0.0f);
    public float VignetteScale = 0.0f;
    public float ChromaticAberrationScale = 0.0f;

    private static readonly SharedUniforms instance = new SharedUniforms();

    static SharedUniforms() {

    }

    private SharedUniforms() {

    }

    public static SharedUniforms singleton {
      get {
        return instance;
      }
    }
  }

  public class PrepassUniforms {
    public float AtmosphereDensity = 0.0f;
    public float AtmosphereSeaLevel = 0.0f;
    public float AtmosphereSeaLevelDensity = 0.0f;
    public Color AtmosphereSkyColor = new Color(0.7f, 0.93f, 1.0f, 1.0f);
    public Color AtmosphereSunColor = new Color(1.0f, 0.99f, 0.83f, 1.0f);
  }
}